<template>
  <GenericLayout>
    <template #header>
      <Header
        :back-button="true"
        :title="pageTitle"
      />
    </template>

    <template
      #page-content
    >
      <div class="full-height column">
        <template v-if="isDesktopPlatform">
          <div
            class="page-title"
            v-if="pageTitle"
          >
            {{ pageTitle }}
          </div>
          <div
            class="page-subtitle"
            v-if="pageSubTitle"
          >
            {{ pageSubTitle }}
          </div>
        </template>
        <q-card
          :square="!isDesktopPlatform"
          class="column no-wrap col"
        >
          <q-banner
            class="bg-grey-3 text-grey-8"
          >
            <translate>The fertilization year of the trees is used to select a different fertilization algorithm for younger trees.</translate>
          </q-banner>

          <q-card-section>
            <q-select
              v-model="storeYoungTreesFertilizationYear"
              :label="$gettext('Fertilization year')"
              :options="youngTreesFertilizationYearOptions"
              option-value="id"
              option-label="label"
              filled
              class="q-mt-md"
            />

            <q-input
              v-model.number="storeYoungTreesPerHa"
              :label="treesPerSurfaceLabel"
              filled
              type="number"
              :rules="[val => (val > 0) || $gettext('This field value must be positive')]"
              :min="0"
              step="1"
              hide-bottom-space
              class="q-mt-md"
            />
          </q-card-section>

          <!-- buttons -->
          <q-card-section class="q-mt-auto">
            <q-card-actions
              class="q-pa-none"
              vertical
              align="stretch"
            >
              <q-btn
                color="primary"
                text-color="white"
                :disable="!canContinue"
                @click="onClickNext"
              >
                <translate>Next</translate>
              </q-btn>
              <q-btn
                flat
                color="primary"
                @click="onClickPrevious"
              >
                <translate>Previous</translate>
              </q-btn>
            </q-card-actions>
          </q-card-section>
        </q-card>
      </div>
    </template>

    <template #footer>
      <Footer />
    </template>
  </GenericLayout>
</template>

<script>
import { PlatformMixin } from 'src/mixins/PlatformMixin'
import GenericLayout from 'src/layouts/GenericLayout'
import Header from 'src/components/layouts/Header'
import Footer from 'src/components/layouts/Footer'
import AlgorithmsMixins from 'src/pages/fieldbook/fertilization/algorithms/common/mixins/AlgorithmsMixins'
import { getConversionRatio } from 'src/services/fieldbook/fertilization/fertilizationPlan'

export default {
  name: 'NavigatorF3YoungTreesPage',
  components: {
    GenericLayout,
    Header,
    Footer
  },
  mixins: [PlatformMixin, AlgorithmsMixins],
  computed: {
    pageTitle () {
      return this.$gettext('Trees')
    },
    pageSubTitle () {
      return 'Navigator F3'
    },
    canContinue () {
      return this.isParameterSet(this.storeYoungTreesPerHa) &&
        this.isParameterSet(this.storeYoungTreesFertilizationYear)
    },
    youngTreesFertilizationYearOptions () {
      const yearOptions = this.storeCropProfile.young_trees.fertilization_years || []
      const olderTreesOption = {
        id: 'young_trees__is_older',
        label: this.$gettext('None of the above: my trees are older')
      }
      return [...yearOptions, olderTreesOption]
    },
    isYoungTrees () {
      return Boolean(this.storeYoungTreesFertilizationYear?.id) && this.storeYoungTreesFertilizationYear?.id !== 'young_trees__is_older'
    },
    displayUnitConfig () {
      return {
        surface: this.$store.state.fertilizationPlan.parameters.displaySurfaceUnit
      }
    },
    treesPerSurfaceLabel () {
      const surfaceUnit = this.displayUnitConfig?.surface?.name || this.$gettext('hectare')
      return this.$gettextInterpolate(this.$gettext('Trees per %{surfaceUnit}'), { surfaceUnit })
    },
    storeCropProfile () {
      return this.$store.state.fertilizationPlan.parameters.cropProfile
    },
    storeYoungTreesPerHa: {
      get () {
        const youngTreesPerHa = this.$store.state.fertilizationPlan.parameters.youngTreesPerHa ?? null
        if (youngTreesPerHa === null) {
          return null
        } else {
          const conversionRatio = getConversionRatio(this.displayUnitConfig)
          return youngTreesPerHa * conversionRatio
        }
      },
      set (v) {
        let value = null
        if (v > 0) {
          const conversionRatio = getConversionRatio(this.displayUnitConfig)
          value = v / conversionRatio
        }
        this.updateParameter('youngTreesPerHa', value)
      }
    },
    storeYoungTreesFertilizationYear: {
      get () {
        return this.$store.state.fertilizationPlan.parameters.youngTreesFertilizationYear
      },
      set (v) {
        this.updateParameter('youngTreesFertilizationYear', v)
      }
    }
  },
  mounted () {
    if (!this.isParameterSet(this.storeYoungTreesPerHa)) {
      this.storeYoungTreesPerHa = this.storeCropProfile.young_trees.trees_per_ha
    }
  },
  methods: {
    onClickNext () {
      const nextRouteName = this.isYoungTrees ? 'navigatorF3YoungTreesFertilization' : 'navigatorF3HarvestAndResidues'
      this.$router.push({
        name: nextRouteName
      })
    },
    onClickPrevious () {
      this.$router.replace({
        name: 'navigatorF3CropProfile',
        query: {
          doNotSkipCropProfile: true
        }
      })
    }
  }
}
</script>
